function y = piston(x)
M = 30 + 30*x(:,1);
S = 0.005 + 0.015*x(:,2);
V0 = 0.002 + 0.008*x(:,3);
Ta = 290 + 6*x(:,4);
T0 = 340 + 20*x(:,5);
P0 = 80000 + 10000*x(:,6);
k = 1000*x(:,7);

A = P0.*S + 19.62*M -k.*V0./S;
V = 0.5*S./k.*(sqrt(A.^2+4*k.*P0.*V0./T0.*Ta)-A);
y = 2*pi*sqrt(M./(k+S.^2.*P0.*V0./V.^2.*Ta./T0));